/usr/bin/update-manager:OverflowError:/usr/bin/update-manager@117

Bug #1654008 reported by errors.ubuntu.com bug bridge on 2017-01-04
26
This bug affects 2 people
Affects Status Importance Assigned to Milestone
update-manager (Ubuntu)
High
Brian Murray
Trusty
High
Brian Murray
Xenial
High
Brian Murray
Yakkety
High
Brian Murray
Zesty
High
Brian Murray
update-notifier (Ubuntu)
High
rahmadani
Trusty
High
Brian Murray
Xenial
High
Brian Murray
Yakkety
High
Brian Murray
Zesty
High
rahmadani

Bug Description

[Impact]
The launch-time key is only designed to hold a 32 bit integer and some day that won't work. Additionally, a lot of people (based off the quantity of crash reports) seem to have their clocks misconfigured (or are living in the future!) which is causing a crash when update-manager tries to write the last launch time.

[Test Case]
1) In a terminal run 'faketime -f '+43y' /usr/bin/update-manager'.
2) Observe a traceback

With the version of update-manager from -proposed you will no longer receive a traceback. The update-notifier change just supports reading the 64 bit integer key and there are no crashes yet because its not trying to read a 64 bit as 32 bits.

[Regression Potential]
Its possible the breaks and depends are incorrect and that people would receive a crash trying to read a 64 bit key as 32 bits. So double check those carefully.

The Ubuntu Error Tracker has been receiving reports about a problem regarding update-manager. This problem was most recently seen with package version 1:16.10.8, the problem page at https://errors.ubuntu.com/problem/6d5b9fd57622f69dc32248c49512ee8fe29b24b3 contains more details, including versions of packages affected, stacktrace or traceback, and individual crash reports.
If you do not have access to the Ubuntu Error Tracker you can request it at http://forms.canonical.com/reports/.

Related branches

Brian Murray (brian-murray) wrote :

Here's the Traceback:

Traceback (most recent call last):
  File "/usr/bin/update-manager", line 117, in <module>
    settings.set_int("launch-time", int(time.time()))
OverflowError: 2852154235 not in range -2147483648 to 2147483647

Changed in update-manager (Ubuntu):
status: New → Triaged
importance: Undecided → High
assignee: nobody → Brian Murray (brian-murray)
milestone: none → ubuntu-17.02
Changed in update-manager (Ubuntu):
milestone: ubuntu-17.02 → ubuntu-17.03
Brian Murray (brian-murray) wrote :

This is reproducable by running update-manager in the future.

$ faketime -f '+43y' /usr/bin/update-manager
Traceback (most recent call last):
  File "/usr/bin/update-manager", line 117, in <module>
    settings.set_int("launch-time", int(time.time()))
OverflowError: 2844966280 not in range -2147483648 to 2147483647

Brian Murray (brian-murray) wrote :

One possible solution would be to convert the dconf key from an int to a string.

desrt (desrt) wrote :

dconf also supports 64-bit types. You could convert from 'i' (int32) to 'x' (int64) and then use g_settings_[gs]et_int64(). That would be a better choice than a string, certainly.

Brian Murray (brian-murray) wrote :

update-manager only ever writes launch--time, but update-notifier reads it so it too will need to be updated.

Brian Murray (brian-murray) wrote :

Given the volume of people affected and the fact that it prevents their ability to install updates we should SRU this everywhere.

Changed in update-notifier (Ubuntu Zesty):
status: New → Triaged
importance: Undecided → High
Changed in update-manager (Ubuntu Zesty):
status: Triaged → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 3.178

---------------
update-notifier (3.178) zesty; urgency=medium

  * Switch to using a 64 bit integer for launch-time as update-manager also
    did. (LP: #1654008)

 -- Brian Murray <email address hidden> Tue, 14 Mar 2017 13:13:41 -0700

Changed in update-notifier (Ubuntu Zesty):
status: Triaged → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:17.04.3

---------------
update-manager (1:17.04.3) zesty; urgency=medium

  * Use a 64 bit integer for launch-time instead of a 32 bit one which won't
    work someday. (LP: #1654008)

 -- Brian Murray <email address hidden> Tue, 14 Mar 2017 14:51:04 -0700

Changed in update-manager (Ubuntu Zesty):
status: In Progress → Fix Released
Changed in update-manager (Ubuntu Yakkety):
assignee: nobody → Brian Murray (brian-murray)
status: New → In Progress
Changed in update-notifier (Ubuntu Yakkety):
assignee: nobody → Brian Murray (brian-murray)
status: New → In Progress
Changed in update-manager (Ubuntu Yakkety):
importance: Undecided → High
Changed in update-notifier (Ubuntu Yakkety):
importance: Undecided → High
description: updated

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-manager into yakkety-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:16.10.9 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-manager (Ubuntu Yakkety):
status: In Progress → Fix Committed
tags: added: verification-needed
Changed in update-notifier (Ubuntu Yakkety):
status: In Progress → Fix Committed
Łukasz Zemczak (sil2100) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-notifier into yakkety-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-notifier/3.175.2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-manager (Ubuntu Xenial):
assignee: nobody → Brian Murray (brian-murray)
importance: Undecided → High
status: New → In Progress
Changed in update-notifier (Ubuntu Xenial):
assignee: nobody → Brian Murray (brian-murray)
importance: Undecided → High
status: New → In Progress
Changed in update-manager (Ubuntu Trusty):
assignee: nobody → Brian Murray (brian-murray)
importance: Undecided → High
status: New → In Progress
Changed in update-notifier (Ubuntu Trusty):
assignee: nobody → Brian Murray (brian-murray)
importance: Undecided → High
status: New → In Progress
Robie Basak (racb) wrote :

From update-manager (1:0.196.23) trusty-proposed:

> +Breaks: update-notifier (<< 3.154.1ubuntu3)

Shouldn't this be 0.154.1ubuntu3?

I would just fix up, but as this is quite finnicky I'd appreciate a second set of eyes on a fixed upload too please.

Brian Murray (brian-murray) wrote :

Yes, it should I likely missed changing the '3' to a '0' when backporting the changes from XYZ.

Adam Conrad (adconrad) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-manager into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:0.196.23 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-manager (Ubuntu Trusty):
status: In Progress → Fix Committed
Changed in update-notifier (Ubuntu Trusty):
status: In Progress → Fix Committed
Adam Conrad (adconrad) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-notifier into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-notifier/0.154.1ubuntu3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-notifier (Ubuntu Xenial):
status: In Progress → Fix Committed
Adam Conrad (adconrad) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-notifier into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-notifier/3.168.4 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-manager (Ubuntu Xenial):
status: In Progress → Fix Committed
Adam Conrad (adconrad) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-manager into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:16.04.6 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Brian Murray (brian-murray) wrote :

I tested the version of update-manager from yakkety-proposed, 1:16.10.9, and confirm that the test case with faketime no longer causes a Traceback.

tags: added: verification-done-yakkety

As a part of the Stable Release Updates quality process a search for Launchpad bug reports using the version of update-notifier from xenial-proposed was performed and bug 1676852 was found. Please investigate this bug report to ensure that a regression will not be created by this SRU. In the event that this is not a regression remove the "verification-failed" tag from this bug report and add the tag "bot-stop-nagging" to bug 1676852 (not this bug). Thanks!

tags: added: verification-failed
tags: removed: verification-failed
rahmadani (rahmadani) on 2017-03-31
Changed in update-notifier (Ubuntu Zesty):
assignee: nobody → rahmadani (rahmadani)
Brian Murray (brian-murray) wrote :

I updated to the packages from xenial-proposed and did not experience a crash using the faketime test case from the bug description.

Log started: 2017-04-05 08:20:24
(Reading database ... ^M(Reading database ... 5%^M(Reading database ... 10%^M(Reading database ... 15%^M(Reading database ... 20%^M(Reading database ... 25%^M(Reading database ... 30%^M(Reading database ... 35%^M(Reading database ... 40%^M(Reading database ... 45%^M(Reading database ... 50%^M(Reading database ... 55%^M(Reading database ... 60%^M(Reading database ... 65%^M(Reading database ... 70%^M(Reading database ... 75%^M(Reading database ... 80%^M(Reading database ... 85%^M(Reading database ... 90%^M(Reading database ... 95%^M(Reading database ... 100%^M(Reading database ... 212826 files and directories currently installed.)^M
Preparing to unpack .../update-notifier_3.168.4_amd64.deb ...^M
Unpacking update-notifier (3.168.4) over (3.168.1) ...^M
Preparing to unpack .../update-manager_1%3a16.04.6_all.deb ...^M
Unpacking update-manager (1:16.04.6) over (1:16.04.3) ...^M
Preparing to unpack .../update-manager-core_1%3a16.04.6_all.deb ...^M
Unpacking update-manager-core (1:16.04.6) over (1:16.04.3) ...^M
Preparing to unpack .../python3-update-manager_1%3a16.04.6_all.deb ...^M
Unpacking python3-update-manager (1:16.04.6) over (1:16.04.3) ...^M
Preparing to unpack .../update-notifier-common_3.168.4_all.deb ...^M
Unpacking update-notifier-common (3.168.4) over (3.168.1) ...^M
Processing triggers for hicolor-icon-theme (0.15-0ubuntu1) ...^M
Processing triggers for libglib2.0-0:amd64 (2.48.1-1~ubuntu16.04.1) ...^M
Processing triggers for gconf2 (3.2.6-3ubuntu6) ...^M
Processing triggers for bamfdaemon (0.5.3~bzr0+16.04.20160824-0ubuntu1) ...^M
Rebuilding /usr/share/applications/bamf-2.index...^M
Processing triggers for gnome-menus (3.13.3-6ubuntu3.1) ...^M
Processing triggers for desktop-file-utils (0.22-1ubuntu5) ...^M
Processing triggers for mime-support (3.59ubuntu1) ...^M
Processing triggers for man-db (2.7.5-1) ...^M
Setting up python3-update-manager (1:16.04.6) ...^M
Setting up update-manager-core (1:16.04.6) ...^M
Setting up update-notifier-common (3.168.4) ...^M
Setting up update-manager (1:16.04.6) ...^M
Setting up update-notifier (3.168.4) ...^M
Log ended: 2017-04-05 08:20:27

Setting to v-done for xenial.

tags: added: verification-done-xenial
Brian Murray (brian-murray) wrote :

I updated to the packages from trusty-proposed and did not experience a crash using the faketime test case from the bug description.

Log started: 2017-04-05 08:27:05
(Reading database ... 208533 files and directories currently installed.)
Preparing to unpack .../update-notifier_0.154.1ubuntu3_amd64.deb ...
Unpacking update-notifier (0.154.1ubuntu3) over (0.154.1ubuntu2) ...
Preparing to unpack .../update-manager_1%3a0.196.23_all.deb ...
Unpacking update-manager (1:0.196.23) over (1:0.196.21) ...
Preparing to unpack .../update-manager-core_1%3a0.196.23_all.deb ...
Unpacking update-manager-core (1:0.196.23) over (1:0.196.21) ...
Preparing to unpack .../python3-update-manager_1%3a0.196.23_all.deb ...
Unpacking python3-update-manager (1:0.196.23) over (1:0.196.21) ...
Preparing to unpack .../update-notifier-common_0.154.1ubuntu3_all.deb ...
Unpacking update-notifier-common (0.154.1ubuntu3) over (0.154.1ubuntu2) ...
Processing triggers for hicolor-icon-theme (0.13-1) ...
Processing triggers for libglib2.0-0:amd64 (2.40.2-0ubuntu1) ...
Processing triggers for gconf2 (3.2.6-0ubuntu2) ...
Processing triggers for gnome-menus (3.10.1-0ubuntu2) ...
Processing triggers for desktop-file-utils (0.22-1ubuntu1) ...
Processing triggers for bamfdaemon (0.5.1+14.04.20140409-0ubuntu1) ...
Rebuilding /usr/share/applications/bamf-2.index...
Processing triggers for mime-support (3.54ubuntu1.1) ...
Processing triggers for man-db (2.6.7.1-1ubuntu1) ...
Setting up python3-update-manager (1:0.196.23) ...
Setting up update-manager-core (1:0.196.23) ...
Setting up update-notifier-common (0.154.1ubuntu3) ...
Setting up update-manager (1:0.196.23) ...
Setting up update-notifier (0.154.1ubuntu3) ...
Log ended: 2017-04-05 08:27:08

Setting to v-done for trusty.

tags: added: verification-done-trusty
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:16.04.6

---------------
update-manager (1:16.04.6) xenial; urgency=medium

  * Use a 64 bit integer for launch-time instead of a 32 bit one which won't
    work someday. (LP: #1654008)

 -- Brian Murray <email address hidden> Mon, 20 Mar 2017 15:03:58 -0700

Changed in update-manager (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for update-manager has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 3.168.4

---------------
update-notifier (3.168.4) xenial; urgency=medium

  * Switch to using a 64 bit integer for launch-time as update-manager also
    did. (LP: #1654008)

 -- Brian Murray <email address hidden> Mon, 20 Mar 2017 09:17:26 -0700

Changed in update-notifier (Ubuntu Xenial):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:0.196.23

---------------
update-manager (1:0.196.23) trusty-proposed; urgency=medium

  * Use a 64 bit integer for launch-time instead of a 32 bit one which won't
    work someday. (LP: #1654008)

 -- Brian Murray <email address hidden> Mon, 20 Mar 2017 18:59:22 -0700

Changed in update-manager (Ubuntu Trusty):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 0.154.1ubuntu3

---------------
update-notifier (0.154.1ubuntu3) trusty-proposed; urgency=medium

  * Switch to using a 64 bit integer for launch-time as update-manager also
    did. (LP: #1654008)

 -- Brian Murray <email address hidden> Mon, 20 Mar 2017 16:13:09 -0700

Changed in update-notifier (Ubuntu Trusty):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:16.10.9

---------------
update-manager (1:16.10.9) yakkety; urgency=medium

  * Use a 64 bit integer for launch-time instead of a 32 bit one which won't
    work someday. (LP: #1654008)

 -- Brian Murray <email address hidden> Fri, 17 Mar 2017 15:41:35 -0700

Changed in update-manager (Ubuntu Yakkety):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-notifier - 3.175.2

---------------
update-notifier (3.175.2) yakkety; urgency=medium

  * Switch to using a 64 bit integer for launch-time as update-manager also
    did. (LP: #1654008)

 -- Brian Murray <email address hidden> Fri, 17 Mar 2017 09:32:57 -0700

Changed in update-notifier (Ubuntu Yakkety):
status: Fix Committed → Fix Released

Im seeing some issues with the package:
https://launchpad.net/ubuntu/+source/update-manager/1:0.196.23
Netinstaller can't find it currently from an official mirror.

Looking at the 16.04 compared to the 14.04 package:
16.04: https://launchpad.net/ubuntu/+source/update-manager/1:16.04.6
14.04: https://launchpad.net/ubuntu/+source/update-manager/1:0.196.23

Looks like the trusty package is only built for i386 and xenial only for amd64 (even though it says all arch in upload details). Is that correct?

I am trying to install a 64-bit machine with netinstall.

Cheers!

Sorry for the noise, just had a look at the .dec file and the https://launchpad.net/ubuntu/trusty/amd64/update-manager/1:0.196.23 where it looks as I expected.

Lars Fronius (l-fronius) wrote :

Hey @Björn, we are seeing the same issue. Oddly, we still had machines building last week of this
on the 13th of April, thus I wonder if this is more of an issue of the trusty repository somehow being out of sync and this only being a symptom?!

Lars Fronius (l-fronius) wrote :

Hey @Björn, we are seeing the same issue as you do. I wonder if this is actually due to a problem with the build, since we still saw proper installation on the 13th of April of update-manager-core

(
see output of on of our 14.04 machines:
ubuntu@ip-10-0-18-215:~$ apt-cache policy update-manager-core
update-manager-core:
  Installed: 1:0.196.23
  Candidate: 1:0.196.23
  Version table:
 *** 1:0.196.23 0
        100 /var/lib/dpkg/status
     1:0.196.11 0
        500 http://us-east-1.ec2.archive.ubuntu.com/ubuntu/ trusty/main amd64 Packages
)

It seems like there has been a faulty update to the mirror, that brought the 0.196.22 back online and thus broke package installation of e.g. update-notifier-common for us.

Colin Watson (cjwatson) wrote :

The fixed version is back now.

Changed in update-manager (Ubuntu Zesty):
milestone: ubuntu-17.03 → none
kostas (mystis25) on 2017-06-24
affects: update-manager (Ubuntu Zesty) → click-update-manager (Ubuntu Zesty)
Steve Langasek (vorlon) on 2017-06-24
affects: click-update-manager (Ubuntu) → update-manager (Ubuntu)
Changed in update-manager (Ubuntu):
milestone: ubuntu-17.03 → none
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers